##########################################################
#
#   Platform independant Makefile for Varkon plotterdrivers
#
#  (C)Microform AB 1999-02-22 J.Kjellander
#
##########################################################

# Include files

INCFILES = ../include/PL.h              \
           ../include/params.h

# The contents of PLlib.a

OBJECTS = ../lib/PLlib.a(pl1.o)         \
          ../lib/PLlib.a(pl2.o)         \
          ../lib/PLlib.a(pl3.o)         \
          ../lib/PLlib.a(pl4.o)         \
          ../lib/PLlib.a(pl5.o)         \
          ../lib/PLlib.a(pl6.o)

# PLlib.a depends on the objects. 

PLlib : $(OBJECTS)


# Objects depend on sources implicitly and sources depend
# on the following include-files.

$(OBJECTS) : $(INCFILES)

# Each driver is a target

postscript: PLlib postscript.c
	$(COMPILE) postscript.c ../../IG/src/ig29.c     \
                   ../lib/PLlib.a -lm -o postscript
	strip postscript
	mv postscript $(VARKON_ROOT)/bin

epson : PLlib epson.c
	$(COMPILE) epson.c ../../IG/src/ig29.c     \
                   ../lib/PLlib.a -lm -o epson
	strip epson
	mv epson $(VARKON_ROOT)/bin

ibmpro : PLlib ibmpro.c
	$(COMPILE) ibmpro.c ../../IG/src/ig29.c     \
                   ../lib/PLlib.a -lm -o ibmpro
	strip ibmpro
	mv ibmpro $(VARKON_ROOT)/bin

hp7475 : PLlib hp7475.c
	$(COMPILE) hp7475.c ../../IG/src/ig29.c     \
                   ../lib/PLlib.a -lm -o hp7475
	strip hp7475
	mv hp7475 $(VARKON_ROOT)/bin

hpcl5  : PLlib hpcl5.c
	$(COMPILE) hpcl5.c ../../IG/src/ig29.c     \
                   ../lib/PLlib.a -lm -o hpcl5
	strip hpcl5
	mv hpcl5 $(VARKON_ROOT)/bin

hpgl2  : PLlib hpgl2.c
	$(COMPILE) hpgl2.c ../../IG/src/ig29.c     \
                   ../lib/PLlib.a -lm -o hpgl2
	strip hpgl2
	mv hpgl2 $(VARKON_ROOT)/bin

gerber : PLlib gerber.c
	$(COMPILE) gerber.c ../../IG/src/ig29.c     \
                   ../lib/PLlib.a -lm -o gerber
	strip gerber
	mv gerber $(VARKON_ROOT)/bin

all : postscript epson ibmpro hp7475 hpcl5 hpgl2 gerber

clean:
	rm -f ../lib/PLlib.a
	rm -f $(VARKON_ROOT)/bin/postscript
	rm -f $(VARKON_ROOT)/bin/epson
	rm -f $(VARKON_ROOT)/bin/ibmpro
	rm -f $(VARKON_ROOT)/bin/hp7475
	rm -f $(VARKON_ROOT)/bin/hpcl5
	rm -f $(VARKON_ROOT)/bin/hpgl2
	rm -f $(VARKON_ROOT)/bin/gerber
